
Ruby - Bug #15906

a=a のような式をもつ条件分岐が意図しない挙動をする

06/07/2019 05:20 AM - nagachika (Tomoyuki Chikanaga)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: 2.6.3 Backport: 2.4: DONTNEED, 2.5: DONE, 2.6:

DONE

Description

[ruby-list:50781] から一部転載します。

下記スクリプトの結果が期待と違います。なぜでしょうか？

a = a は不要ですが、なにもしないことを明示するために書いたものです。

なおOS付属の ruby 2.3.7p456 では期待通りの結果でした。

a = "aaa"

if a == "bbb" || a == "ccc" then

    a = a

else

    puts "OK"

end

puts "END"

実行結果　

　END

期待する結果　

　OK

　END

動作環境

　MacOS 10.13.6

　ruby 2.6.3p62 (2019-04-16 revision 67580) [x86_64-darwin17]

　macportsでインストール

 r63870 から発生するようになっているようです。

Associated revisions

Revision a6a26e42b15c46f117f4fce07a2050e9d727355d - 06/07/2019 05:46 AM - mame (Yusuke Endoh)

compile.c: Partially revert r63870 which caused wrong optimization

[Bug #15906]

Revision a6a26e42b15c46f117f4fce07a2050e9d727355d - 06/07/2019 05:46 AM - mame (Yusuke Endoh)

compile.c: Partially revert r63870 which caused wrong optimization

[Bug #15906]

Revision a6a26e42 - 06/07/2019 05:46 AM - mame (Yusuke Endoh)

compile.c: Partially revert r63870 which caused wrong optimization

[Bug #15906]

Revision 4e12051fe885f93eb5ce8eb114f6ee944b417035 - 07/28/2019 02:16 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d: [Backport #15906]
    compile.c: Partially revert r63870 which caused wrong optimization

    [Bug #15906]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67716 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4e12051fe885f93eb5ce8eb114f6ee944b417035 - 07/28/2019 02:16 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d: [Backport #15906]

    compile.c: Partially revert r63870 which caused wrong optimization

    [Bug #15906]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67716 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4e12051f - 07/28/2019 02:16 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d: [Backport #15906]

    compile.c: Partially revert r63870 which caused wrong optimization

    [Bug #15906]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67716 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 235e64c2474d40789d39306dda1cc415310a50b0 - 08/26/2019 02:45 PM - U.Nakamura 

merge revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d: [Backport #15906]

    compile.c: Partially revert r63870 which caused wrong optimization

    [Bug #15906]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@67757 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 235e64c2474d40789d39306dda1cc415310a50b0 - 08/26/2019 02:45 PM - U.Nakamura 

merge revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d: [Backport #15906]

    compile.c: Partially revert r63870 which caused wrong optimization

    [Bug #15906]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@67757 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 235e64c2 - 08/26/2019 02:45 PM - U.Nakamura 

merge revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d: [Backport #15906]

    compile.c: Partially revert r63870 which caused wrong optimization

    [Bug #15906]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@67757 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/07/2019 05:47 AM - mame (Yusuke Endoh)

- Status changed from Open to Closed

Applied in changeset git|a6a26e42b15c46f117f4fce07a2050e9d727355d.

compile.c: Partially revert r63870 which caused wrong optimization

[Bug #15906]

#2 - 07/28/2019 02:16 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.4: DONTNEED, 2.5: REQUIRED, 2.6: REQUIRED to 2.4: DONTNEED, 2.5: REQUIRED, 2.6: DONE

ruby_2_6 r67716 merged revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d.

#3 - 08/26/2019 02:45 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.4: DONTNEED, 2.5: REQUIRED, 2.6: DONE to 2.4: DONTNEED, 2.5: DONE, 2.6: DONE
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/a6a26e42b15c46f117f4fce07a2050e9d727355d
https://bugs.ruby-lang.org/issues/15906


ruby_2_5 r67757 merged revision(s) a6a26e42b15c46f117f4fce07a2050e9d727355d.
